Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimizer/3.3/StartPage.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimizer/3.3/StartPage.cs	(revision 17241)
@@ -110,6 +110,7 @@
         }
 
+      } catch {
+      } finally {
         OnAllSamplesLoaded();
-      } finally {
         Progress.HideFromControl(samplesListView);
       }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeuristicLab.Problems.TravelingSalesman.Views-3.3.csproj
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeuristicLab.Problems.TravelingSalesman.Views-3.3.csproj	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeuristicLab.Problems.TravelingSalesman.Views-3.3.csproj	(revision 17241)
@@ -128,10 +128,4 @@
     </Compile>
     <Compile Include="Plugin.cs" />
-    <Compile Include="TravelingSalesmanProblemView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="TravelingSalesmanProblemView.Designer.cs">
-      <DependentUpon>TravelingSalesmanProblemView.cs</DependentUpon>
-    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman.Views/3.3/PathTSPTourView.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman.Views/3.3/PathTSPTourView.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman.Views/3.3/PathTSPTourView.cs	(revision 17241)
@@ -21,4 +21,5 @@
 
 using System;
+using System.ComponentModel;
 using System.Drawing;
 using System.Windows.Forms;
@@ -48,14 +49,10 @@
 
     protected override void DeregisterContentEvents() {
-      Content.QualityChanged -= new EventHandler(Content_QualityChanged);
-      Content.CoordinatesChanged -= new EventHandler(Content_CoordinatesChanged);
-      Content.PermutationChanged -= new EventHandler(Content_PermutationChanged);
+      Content.PropertyChanged -= ContentOnPropertyChanged;
       base.DeregisterContentEvents();
     }
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.QualityChanged += new EventHandler(Content_QualityChanged);
-      Content.CoordinatesChanged += new EventHandler(Content_CoordinatesChanged);
-      Content.PermutationChanged += new EventHandler(Content_PermutationChanged);
+      Content.PropertyChanged += ContentOnPropertyChanged;
     }
 
@@ -67,7 +64,7 @@
         tourViewHost.Content = null;
       } else {
-        qualityViewHost.Content = Content.Quality;
+        qualityViewHost.Content = Content.TourLength;
         GenerateImage();
-        tourViewHost.Content = Content.Permutation;
+        tourViewHost.Content = Content.Tour;
       }
     }
@@ -86,5 +83,5 @@
         } else {
           DoubleMatrix coordinates = Content.Coordinates;
-          Permutation permutation = Content.Permutation;
+          Permutation permutation = Content.Tour;
           Bitmap bitmap = new Bitmap(pictureBox.Width, pictureBox.Height);
 
@@ -133,22 +130,20 @@
     }
 
-    private void Content_QualityChanged(object sender, EventArgs e) {
+    private void ContentOnPropertyChanged(object sender, PropertyChangedEventArgs e) {
       if (InvokeRequired)
-        Invoke(new EventHandler(Content_QualityChanged), sender, e);
-      else
-        qualityViewHost.Content = Content.Quality;
-    }
-    private void Content_CoordinatesChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_CoordinatesChanged), sender, e);
-      else
-        GenerateImage();
-    }
-    private void Content_PermutationChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_PermutationChanged), sender, e);
+        Invoke((Action<object, PropertyChangedEventArgs>)ContentOnPropertyChanged, sender, e);
       else {
-        GenerateImage();
-        tourViewHost.Content = Content.Permutation;
+        switch (e.PropertyName) {
+          case nameof(Content.Coordinates):
+            GenerateImage();
+            break;
+          case nameof(Content.Tour):
+            GenerateImage();
+            tourViewHost.Content = Content.Tour;
+            break;
+          case nameof(Content.TourLength):
+            qualityViewHost.Content = Content.TourLength;
+            break;
+        }
       }
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/Analyzers/TSPAlleleFrequencyAnalyzer.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/Analyzers/TSPAlleleFrequencyAnalyzer.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/Analyzers/TSPAlleleFrequencyAnalyzer.cs	(revision 17241)
@@ -20,12 +20,10 @@
 #endregion
 
-using System;
+using HEAL.Attic;
 using HeuristicLab.Analysis;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.TravelingSalesman {
@@ -34,20 +32,17 @@
   /// </summary>
   [Item("TSPAlleleFrequencyAnalyzer", "An operator for analyzing the frequency of alleles in solutions of Traveling Salesman Problems given in path representation.")]
-  [StorableType("C1BBEC5A-27EF-4882-AEC6-0919FC2EF1DB")]
+  [StorableType("43a9ec34-c917-43f8-bd14-4d42e2d0a458")]
   public sealed class TSPAlleleFrequencyAnalyzer : AlleleFrequencyAnalyzer<Permutation> {
-    public LookupParameter<DoubleMatrix> CoordinatesParameter {
-      get { return (LookupParameter<DoubleMatrix>)Parameters["Coordinates"]; }
-    }
-    public LookupParameter<DistanceMatrix> DistanceMatrixParameter {
-      get { return (LookupParameter<DistanceMatrix>)Parameters["DistanceMatrix"]; }
-    }
+    [Storable] public ILookupParameter<ITSPData> TSPDataParameter { get; private set; }
 
     [StorableConstructor]
     private TSPAlleleFrequencyAnalyzer(StorableConstructorFlag _) : base(_) { }
-    private TSPAlleleFrequencyAnalyzer(TSPAlleleFrequencyAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    private TSPAlleleFrequencyAnalyzer(TSPAlleleFrequencyAnalyzer original, Cloner cloner)
+      : base(original, cloner) {
+      TSPDataParameter = cloner.Clone(original.TSPDataParameter);
+    }
     public TSPAlleleFrequencyAnalyzer()
       : base() {
-      Parameters.Add(new LookupParameter<DoubleMatrix>("Coordinates", "The x- and y-coordinates of the cities."));
-      Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix", "The matrix which contains the distances between the cities."));
+      Parameters.Add(TSPDataParameter = new LookupParameter<ITSPData>("TSPData", "The main parameters of the TSP."));
     }
 
@@ -57,8 +52,6 @@
 
     protected override Allele[] CalculateAlleles(Permutation solution) {
+      var tspData = TSPDataParameter.ActualValue;
       Allele[] alleles = new Allele[solution.Length];
-      DoubleMatrix coords = CoordinatesParameter.ActualValue;
-      DistanceMatrix dm = DistanceMatrixParameter.ActualValue;
-      if (dm == null && coords == null) throw new InvalidOperationException("Neither a distance matrix nor coordinates were given.");
       int source, target, h;
       double impact;
@@ -68,5 +61,5 @@
         target = solution[i + 1];
         if (source > target) { h = source; source = target; target = h; }
-        impact = dm != null ? dm[source, target] : CalculateLength(coords[source, 0], coords[source, 1], coords[target, 0], coords[target, 1]);
+        impact = tspData.GetDistance(source, target);
         alleles[i] = new Allele(source.ToString() + "-" + target.ToString(), impact);
       }
@@ -74,13 +67,9 @@
       target = solution[0];
       if (source > target) { h = source; source = target; target = h; }
-      impact = dm != null ? dm[source, target] : CalculateLength(coords[source, 0], coords[source, 1], coords[target, 0], coords[target, 1]);
+      impact = tspData.GetDistance(source, target);
       alleles[alleles.Length - 1] = new Allele(source.ToString() + "-" + target.ToString(), impact);
 
       return alleles;
     }
-
-    private double CalculateLength(double x1, double y1, double x2, double y2) {
-      return Math.Sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
-    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/HeuristicLab.Problems.TravelingSalesman-3.3.csproj
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/HeuristicLab.Problems.TravelingSalesman-3.3.csproj	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/HeuristicLab.Problems.TravelingSalesman-3.3.csproj	(revision 17241)
@@ -118,41 +118,13 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Analyzers\BestTSPSolutionAnalyzer.cs" />
-    <Compile Include="Analyzers\TSPPopulationDiversityAnalyzer.cs" />
     <Compile Include="Analyzers\TSPAlleleFrequencyAnalyzer.cs" />
-    <Compile Include="DistanceMatrix.cs" />
-    <Compile Include="Evaluators\TSPDistanceMatrixEvaluator.cs" />
-    <Compile Include="Evaluators\TSPEuclideanPathEvaluator.cs" />
-    <Compile Include="Evaluators\TSPGeoPathEvaluator.cs" />
-    <Compile Include="Evaluators\TSPUpperEuclideanPathEvaluator.cs" />
     <Compile Include="Improvers\TSPImprovementOperator.cs" />
-    <Compile Include="Interfaces\ITSPDistanceMatrixEvaluator.cs" />
-    <Compile Include="MoveEvaluators\ThreeOpt\TSPTranslocationMoveDistanceMatrixEvaluator.cs" />
-    <Compile Include="MoveEvaluators\ThreeOpt\TSPTranslocationMoveEuclideanPathEvaluator.cs" />
-    <Compile Include="MoveEvaluators\ThreeOpt\TSPTranslocationMoveGeoPathEvaluator.cs" />
-    <Compile Include="MoveEvaluators\ThreeOpt\TSPTranslocationMovePathEvaluator.cs" />
-    <Compile Include="MoveEvaluators\ThreeOpt\TSPTranslocationMoveRoundedEuclideanPathEvaluator.cs" />
-    <Compile Include="MoveEvaluators\TwoOpt\TSPInversionMoveEuclideanPathEvaluator.cs" />
-    <Compile Include="MoveEvaluators\TwoOpt\TSPInversionMoveGeoPathEvaluator.cs" />
-    <Compile Include="MoveEvaluators\TwoOpt\TSPInversionMoveDistanceMatrixEvaluator.cs" />
-    <Compile Include="MoveEvaluators\TwoOpt\TSPInversionMovePathEvaluator.cs" />
-    <Compile Include="MoveEvaluators\TwoOpt\TSPInversionMoveRoundedEuclideanPathEvaluator.cs" />
+    <Compile Include="MoveEvaluators\ThreeOpt\TSPTranslocationMoveEvaluator.cs" />
+    <Compile Include="MoveEvaluators\TSPMoveEvaluator.cs" />
+    <Compile Include="MoveEvaluators\TwoOpt\TSPInversionMoveEvaluator.cs" />
     <Compile Include="PathRelinkers\TSPMultipleGuidesPathRelinker.cs" />
     <Compile Include="PathRelinkers\TSPPathRelinker.cs" />
     <Compile Include="PathRelinkers\TSPSimultaneousPathRelinker.cs" />
     <Compile Include="Plugin.cs" />
-    <Compile Include="SimilarityCalculators\TSPSimilarityCalculator.cs" />
-    <Compile Include="TravelingSalesmanProblem.cs" />
-    <Compile Include="PathTSPTour.cs" />
-    <Compile Include="Evaluators\TSPCoordinatesPathEvaluator.cs" />
-    <Compile Include="Evaluators\TSPEvaluator.cs" />
-    <Compile Include="Evaluators\TSPRoundedEuclideanPathEvaluator.cs" />
-    <Compile Include="Interfaces\ITSPCoordinatesPathEvaluator.cs" />
-    <Compile Include="Interfaces\ITSPEvaluator.cs" />
-    <Compile Include="Interfaces\ITSPMoveEvaluator.cs" />
-    <Compile Include="Interfaces\ITSPPathEvaluator.cs" />
-    <Compile Include="Interfaces\ITSPPathMoveEvaluator.cs" />
-    <Compile Include="MoveEvaluators\TSPPathMoveEvaluator.cs" />
-    <Compile Include="MoveEvaluators\TSPMoveEvaluator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="TSP.cs" />
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/Improvers/TSPImprovementOperator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/Improvers/TSPImprovementOperator.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/Improvers/TSPImprovementOperator.cs	(revision 17241)
@@ -21,4 +21,5 @@
 
 using System;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -28,5 +29,4 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.TravelingSalesman {
@@ -38,53 +38,33 @@
   /// </remarks>
   [Item("TSPImprovementOperator", "An operator that improves traveling salesman solutions. The operator tries to improve the traveling salesman solution by swapping two randomly chosen edges for a certain number of times.")]
-  [StorableType("9C3B53A4-8FE7-45FC-833B-FF3DAE578010")]
+  [StorableType("1b3cbc66-6dcc-4f61-9cbe-8b50cc54413a")]
   public sealed class TSPImprovementOperator : SingleSuccessorOperator, ISingleObjectiveImprovementOperator {
-    #region Parameter properties
-    public ScopeParameter CurrentScopeParameter {
-      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    
+    [Storable] public ILookupParameter<ITSPData> TSPDataParameter { get; private set; }
+    [Storable] public IValueParameter<IntValue> ImprovementAttemptsParameter { get; private set; }
+    [Storable] public ILookupParameter<IRandom> RandomParameter { get; private set; }
+    [Storable] public IValueLookupParameter<IItem> SolutionParameter { get; private set; }
+
+    public int ImprovementAttempts {
+      get { return ImprovementAttemptsParameter.Value.Value; }
+      set { ImprovementAttemptsParameter.Value.Value = value; }
     }
-    public ILookupParameter<DistanceMatrix> DistanceMatrixParameter {
-      get { return (ILookupParameter<DistanceMatrix>)Parameters["DistanceMatrix"]; }
-    }
-    public IValueParameter<IntValue> ImprovementAttemptsParameter {
-      get { return (IValueParameter<IntValue>)Parameters["ImprovementAttempts"]; }
-    }
-    public ILookupParameter<IRandom> RandomParameter {
-      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
-    }
-    public IValueLookupParameter<IItem> SolutionParameter {
-      get { return (IValueLookupParameter<IItem>)Parameters["Solution"]; }
-    }
-    #endregion
-
-    #region Properties
-    public IScope CurrentScope {
-      get { return CurrentScopeParameter.ActualValue; }
-    }
-    public DistanceMatrix DistanceMatrix {
-      get { return DistanceMatrixParameter.ActualValue; }
-      set { DistanceMatrixParameter.ActualValue = value; }
-    }
-    public IntValue ImprovementAttempts {
-      get { return ImprovementAttemptsParameter.Value; }
-      set { ImprovementAttemptsParameter.Value = value; }
-    }
-    public IRandom Random {
-      get { return RandomParameter.ActualValue; }
-      set { RandomParameter.ActualValue = value; }
-    }
-    #endregion
 
     [StorableConstructor]
     private TSPImprovementOperator(StorableConstructorFlag _) : base(_) { }
-    private TSPImprovementOperator(TSPImprovementOperator original, Cloner cloner) : base(original, cloner) { }
+    private TSPImprovementOperator(TSPImprovementOperator original, Cloner cloner)
+      : base(original, cloner) {
+      TSPDataParameter = cloner.Clone(original.TSPDataParameter);
+      ImprovementAttemptsParameter = cloner.Clone(original.ImprovementAttemptsParameter);
+      RandomParameter = cloner.Clone(original.RandomParameter);
+      SolutionParameter = cloner.Clone(original.SolutionParameter);
+    }
     public TSPImprovementOperator()
       : base() {
       #region Create parameters
-      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope that contains the solution to be improved."));
-      Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix", "The matrix which contains the distances between the cities."));
-      Parameters.Add(new ValueParameter<IntValue>("ImprovementAttempts", "The number of improvement attempts the operator should perform.", new IntValue(100)));
-      Parameters.Add(new LookupParameter<IRandom>("Random", "A pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<IItem>("Solution", "The solution to be improved. This parameter is used for name translation only."));
+      Parameters.Add(TSPDataParameter = new LookupParameter<ITSPData>("TSPData", "The main parameters of the TSP."));
+      Parameters.Add(ImprovementAttemptsParameter = new ValueParameter<IntValue>("ImprovementAttempts", "The number of improvement attempts the operator should perform.", new IntValue(100)));
+      Parameters.Add(RandomParameter = new LookupParameter<IRandom>("Random", "A pseudo random number generator."));
+      Parameters.Add(SolutionParameter = new ValueLookupParameter<IItem>("Solution", "The solution to be improved. This parameter is used for name translation only."));
       #endregion
     }
@@ -95,18 +75,20 @@
 
     public override IOperation Apply() {
-      var solution = CurrentScope.Variables[SolutionParameter.ActualName].Value as Permutation;
+      var random = RandomParameter.ActualValue;
+      var solution = ExecutionContext.Scope.Variables[SolutionParameter.ActualName].Value as Permutation;
       if (solution == null)
         throw new ArgumentException("Cannot improve solution because it has the wrong type.");
       if (solution.PermutationType != PermutationTypes.RelativeUndirected)
         throw new ArgumentException("Cannot improve solution because the permutation type is not supported.");
+      var tspData = TSPDataParameter.ActualValue;
 
-      for (int i = 0; i < ImprovementAttempts.Value; i++) {
-        var move = StochasticInversionSingleMoveGenerator.Apply(solution, Random);
-        double moveQualtiy = TSPInversionMovePathEvaluator.EvaluateByDistanceMatrix(solution, move, DistanceMatrix);
+      for (int i = 0; i < ImprovementAttempts; i++) {
+        var move = StochasticInversionSingleMoveGenerator.Apply(solution, random);
+        double moveQualtiy = TSPInversionMoveEvaluator.CalculateTourLengthDelta(tspData, solution, move);
         if (moveQualtiy < 0)
           InversionManipulator.Apply(solution, move.Index1, move.Index2);
       }
 
-      CurrentScope.Variables.Add(new Variable("LocalEvaluatedSolutions", ImprovementAttempts));
+      ExecutionContext.Scope.Variables.Add(new Variable("LocalEvaluatedSolutions", new IntValue(ImprovementAttempts)));
 
       return base.Apply();
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/TSPMoveEvaluator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/TSPMoveEvaluator.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/TSPMoveEvaluator.cs	(revision 17241)
@@ -1,60 +1,54 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
+﻿using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.TravelingSalesman {
-  /// <summary>
-  /// A base class for operators which evaluate TSP solutions.
-  /// </summary>
-  [Item("TSPMoveEvaluator", "A base class for operators which evaluate TSP moves.")]
-  [StorableType("25573174-DE4B-4076-B439-CCB5F01CE652")]
-  public abstract class TSPMoveEvaluator : SingleSuccessorOperator, ITSPMoveEvaluator, IMoveOperator {
+  [StorableType("17477ad2-2c84-4b02-b5ac-f35ef6cc667f")]
+  public interface ITSPMoveEvaluator : IOperator {
+    ILookupParameter<Permutation> TSPTourParameter { get; }
+    ILookupParameter<ITSPData> TSPDataParameter { get; }
+    ILookupParameter<DoubleValue> TourLengthParameter { get; }
+    ILookupParameter<DoubleValue> TourLengthWithMoveParameter { get; }
+  }
 
-    public abstract Type EvaluatorType { get; }
-    public override bool CanChangeName {
-      get { return false; }
-    }
-
-    public ILookupParameter<DoubleValue> QualityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
-    }
-    public ILookupParameter<DoubleValue> MoveQualityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["MoveQuality"]; }
-    }
+  [Item("TSP Move Evaluator", "Base class for all move evaluators of the TSP.")]
+  [StorableType("44af3845-ccdf-4014-805a-5878c64f67f5")]
+  public abstract class TSPMoveEvaluator : SingleSuccessorOperator, ITSPMoveEvaluator {
+    [Storable] public ILookupParameter<Permutation> TSPTourParameter { get; private set; }
+    [Storable] public ILookupParameter<ITSPData> TSPDataParameter { get; private set; }
+    [Storable] public ILookupParameter<DoubleValue> TourLengthParameter { get; private set; }
+    [Storable] public ILookupParameter<DoubleValue> TourLengthWithMoveParameter { get; private set; }
 
     [StorableConstructor]
     protected TSPMoveEvaluator(StorableConstructorFlag _) : base(_) { }
-    protected TSPMoveEvaluator(TSPMoveEvaluator original, Cloner cloner) : base(original, cloner) { }
-    protected TSPMoveEvaluator()
-      : base() {
-      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of a TSP solution."));
-      Parameters.Add(new LookupParameter<DoubleValue>("MoveQuality", "The evaluated quality of a move on a TSP solution."));
+    protected TSPMoveEvaluator(TSPMoveEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+      TSPTourParameter = cloner.Clone(original.TSPTourParameter);
+      TSPDataParameter = cloner.Clone(original.TSPDataParameter);
+      TourLengthParameter = cloner.Clone(original.TourLengthParameter);
+      TourLengthWithMoveParameter = cloner.Clone(original.TourLengthWithMoveParameter);
     }
+    public TSPMoveEvaluator() {
+      Parameters.Add(TSPTourParameter = new LookupParameter<Permutation>("TSPTour", "The tour that describes a solution to the TSP."));
+      Parameters.Add(TSPDataParameter = new LookupParameter<ITSPData>("TSPData", "The main parameters of the TSP."));
+      Parameters.Add(TourLengthParameter = new LookupParameter<DoubleValue>("TourLength", "The length of a TSP tour."));
+      Parameters.Add(TourLengthWithMoveParameter = new LookupParameter<DoubleValue>("TourLengthWithMove", "The length of the TSP tour if the move was applied."));
+    }
+
+    public sealed override IOperation Apply() {
+      var tour = TSPTourParameter.ActualValue;
+      var tspData = TSPDataParameter.ActualValue;
+      var tourLength = TourLengthParameter.ActualValue.Value;
+      TourLengthWithMoveParameter.ActualValue = new DoubleValue(
+        CalculateTourLengthWithMove(tspData, tour, tourLength)
+      );
+      return base.Apply();
+    }
+
+    protected abstract double CalculateTourLengthWithMove(ITSPData tspData, Permutation tspTour, double tourLength);
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/ThreeOpt/TSPTranslocationMoveEvaluator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/ThreeOpt/TSPTranslocationMoveEvaluator.cs	(revision 17241)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/ThreeOpt/TSPTranslocationMoveEvaluator.cs	(revision 17241)
@@ -0,0 +1,89 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Problems.TravelingSalesman {
+  /// <summary>
+  /// An operator to evaluate a translocation or insertion move.
+  /// </summary>
+  [Item("TSP Translocation Move Evaluator", "Evaluates a translocation or insertion move (3-opt) by an efficient delta computation.")]
+  [StorableType("3f13bc93-778e-4b9b-8285-1b807886a653")]
+  public class TSPTranslocationMoveEvaluator : TSPMoveEvaluator, IPermutationTranslocationMoveOperator {
+    [Storable] public ILookupParameter<TranslocationMove> MoveParameter { get; private set; }
+
+    ILookupParameter<TranslocationMove> IPermutationTranslocationMoveOperator.TranslocationMoveParameter => MoveParameter;
+    ILookupParameter<Permutation> IPermutationMoveOperator.PermutationParameter => TSPTourParameter;
+
+    [StorableConstructor]
+    protected TSPTranslocationMoveEvaluator(StorableConstructorFlag _) : base(_) { }
+    protected TSPTranslocationMoveEvaluator(TSPTranslocationMoveEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+      MoveParameter = cloner.Clone(original.MoveParameter);
+    }
+    public TSPTranslocationMoveEvaluator()
+      : base() {
+      Parameters.Add(MoveParameter = new LookupParameter<TranslocationMove>("TranslocationMove", "The move to evaluate."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TSPTranslocationMoveEvaluator(this, cloner);
+    }
+
+    protected override double CalculateTourLengthWithMove(ITSPData tspData, Permutation tspTour, double tourLength) {
+      var move = MoveParameter.ActualValue;
+      return CalculateTourLengthDelta(tspData, tspTour, move);
+    }
+
+    public static double CalculateTourLengthDelta(ITSPData tspData, Permutation tspTour, TranslocationMove move) {
+      if (move.Index1 == move.Index3
+        || move.Index2 == tspTour.Length - 1 && move.Index3 == 0
+        || move.Index1 == 0 && move.Index3 == tspTour.Length - 1 - move.Index2) return 0;
+
+      int edge1source = tspTour.GetCircular(move.Index1 - 1);
+      int edge1target = tspTour[move.Index1];
+      int edge2source = tspTour[move.Index2];
+      int edge2target = tspTour.GetCircular(move.Index2 + 1);
+      int edge3source, edge3target;
+      if (move.Index3 > move.Index1) {
+        edge3source = tspTour.GetCircular(move.Index3 + move.Index2 - move.Index1);
+        edge3target = tspTour.GetCircular(move.Index3 + move.Index2 - move.Index1 + 1);
+      } else {
+        edge3source = tspTour.GetCircular(move.Index3 - 1);
+        edge3target = tspTour[move.Index3];
+      }
+      double moveQuality = 0;
+      // remove three edges
+      moveQuality -= tspData.GetDistance(edge1source, edge1target);
+      moveQuality -= tspData.GetDistance(edge2source, edge2target);
+      moveQuality -= tspData.GetDistance(edge3source, edge3target);
+      // add three edges
+      moveQuality += tspData.GetDistance(edge3source, edge1target);
+      moveQuality += tspData.GetDistance(edge2source, edge3target);
+      moveQuality += tspData.GetDistance(edge1source, edge2target);
+      return moveQuality;
+    }
+  }
+}
